/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 4, 2007   Ҳڹ()   Class ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.conf.manager;

import java.awt.Component;
import java.io.File;
import java.util.HashMap;

import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JTextField;

import net.infonode.tabbedpanel.TabbedPanel;

import com.nate.hjy7942.ui.dialog.ProgressDialog;
import com.nate.hjy7942.ui.tabmodule.inter.TabComponentInterface;


/**
 * ۼ : Aug 4, 2007
 * ۼ : Ҳڹ() 
 * <br>
 * α׷ Main Ǵ Class Դϴ.
 */

public class MainFrame extends JFrame {
	
	private FrameConfigManager configManager = null;  //α׷ UI  ϴ ü.
	
	//Mainȭ鿡  Split
	private JSplitPane splitWestCenter = null;
	private JSplitPane splitNorthCenter = null;
	private JSplitPane splitNorthWestCenter = null;
	private JSplitPane splitNorthCenterEast = null;
	
	//Mainȭ鿡  TabbedPane
	private TabbedPanel tabbedWest = null;
	private TabbedPanel tabbedCenterNorth_1 = null;
	private TabbedPanel tabbedCenterNorth_2 = null;
	private TabbedPanel tabbedCenterNorth_3 = null;
	private TabbedPanel tabbedCenterCenter = null;
	
	//Mainȭ鿡  Panel
	private JPanel panelNorth = null;
	private JPanel panelSouth = null;
	private JPanel panelWest = null;
	private JPanel panelCenterNorter_1 = null;
	private JPanel panelCenterNorter_2 = null;
	private JPanel panelCenterNorter_3 = null;
	private JPanel panelCenterCenter = null;
	
	//¹ٿ Ǵ TextField
	private JTextField currentStateWorkField = null;
	private JTextField currentStateAbleField = null;
	private JTextField currentStateInsertField = null;
	private JTextField currentStateCursorLocField = null;
	private JTextField currentStateEncordingField = null;
	
	// ۾ ũ ̽ .
	private String workSpaceFolder = null;
	private String currentProjectFolder = null;
	private String currentProjectPlsqlFolder = null;
	private String currentProjectJspFolder = null;
	
	private HashMap<String, Component> toolBarMap = new HashMap<String, Component>();
	private HashMap<String, Component> menuMap = new HashMap<String, Component>();
	private HashMap<String, TabComponentInterface> tabTitledMap = new HashMap<String, TabComponentInterface>();
	
	/**
	 * ڰ  ǰ Ǹ, FrameConfigManager ü ؼ α׷ UI,  оͼ,
	 * α׷  ǰ ȴ.
	 */
	public MainFrame(){
		ProgressDialog.showDialog(this);

		ProgressDialog.setProgressValue(3, "ConfigManage մϴ ...");
		configManager = new FrameConfigManager(this);
		ProgressDialog.setProgressValue(10, "LookAndFeel մϴ ...");
		configManager.setLookAndFeel();    //LookAndFeel  մϴ.
		ProgressDialog.setProgressValue(30, "Frame մϴ...");
		configManager.buildFrame();        //Frame  մϴ.
		ProgressDialog.setProgressValue(50, "Menu մϴ...");
		configManager.buildMenuBar();      //MenuBar  մϴ.
		ProgressDialog.setProgressValue(70, "ToolBar մϴ...");
		configManager.buildToolBar();      //ToolBar  մϴ.
		ProgressDialog.setProgressValue(90, "Program ȭ մϴ...");
		configManager.buildLayout();	   //ȭ Layouy ϴ.
		ProgressDialog.setProgressValue(99, "Program StateBar մϴ...");
		configManager.buildStateBar();     //StateBar  մϴ.
		
		ProgressDialog.disappearDialog();
		this.setVisible(true);
		configManager.loadWorkSpaceInfo();  //α׷ ۿ ʿ ⺻  оɴϴ.   
		configManager.loadProjectInfo();
		configManager.buildComponent();    // Layout   մϴ.
	}
	
	/**
	 * @return α׷ Ǿ ޴ٸ .
	 */
	public JMenuBar getProgramMenuBar(){
		return this.getJMenuBar();	
	}

	/**
	 * @return the currentStateAbleField
	 */
	public JTextField getCurrentStateAbleField() {
		return currentStateAbleField;
	}

	/**
	 * @param currentStateAbleField the currentStateAbleField to set
	 */
	public void setCurrentStateAbleField(JTextField currentStateAbleField) {
		this.currentStateAbleField = currentStateAbleField;
	}

	/**
	 * @return the currentStateCursorLocField
	 */
	public JTextField getCurrentStateCursorLocField() {
		return currentStateCursorLocField;
	}

	/**
	 * @param currentStateCursorLocField the currentStateCursorLocField to set
	 */
	public void setCurrentStateCursorLocField(JTextField currentStateCursorLocField) {
		this.currentStateCursorLocField = currentStateCursorLocField;
	}

	/**
	 * @return the currentStateEncordingField
	 */
	public JTextField getCurrentStateEncordingField() {
		return currentStateEncordingField;
	}

	/**
	 * @param currentStateEncordingField the currentStateEncordingField to set
	 */
	public void setCurrentStateEncordingField(JTextField currentStateEncordingField) {
		this.currentStateEncordingField = currentStateEncordingField;
	}

	/**
	 * @return the currentStateInsertField
	 */
	public JTextField getCurrentStateInsertField() {
		return currentStateInsertField;
	}

	/**
	 * @param currentStateInsertField the currentStateInsertField to set
	 */
	public void setCurrentStateInsertField(JTextField currentStateInsertField) {
		this.currentStateInsertField = currentStateInsertField;
	}

	/**
	 * @return the currentStateWorkField
	 */
	public JTextField getCurrentStateWorkField() {
		return currentStateWorkField;
	}

	/**
	 * @param currentStateWorkField the currentStateWorkField to set
	 */
	public void setCurrentStateWorkField(JTextField currentStateWorkField) {
		this.currentStateWorkField = currentStateWorkField;
	}

	/**
	 * @return the panelCenterCenter
	 */
	public JPanel getPanelCenterCenter() {
		return panelCenterCenter;
	}

	/**
	 * @param panelCenterCenter the panelCenterCenter to set
	 */
	public void setPanelCenterCenter(JPanel panelCenterCenter) {
		this.panelCenterCenter = panelCenterCenter;
	}

	/**
	 * @return the panelCenterNorter_1
	 */
	public JPanel getPanelCenterNorter_1() {
		return panelCenterNorter_1;
	}

	/**
	 * @param panelCenterNorter_1 the panelCenterNorter_1 to set
	 */
	public void setPanelCenterNorter_1(JPanel panelCenterNorter_1) {
		this.panelCenterNorter_1 = panelCenterNorter_1;
	}

	/**
	 * @return the panelCenterNorter_2
	 */
	public JPanel getPanelCenterNorter_2() {
		return panelCenterNorter_2;
	}

	/**
	 * @param panelCenterNorter_2 the panelCenterNorter_2 to set
	 */
	public void setPanelCenterNorter_2(JPanel panelCenterNorter_2) {
		this.panelCenterNorter_2 = panelCenterNorter_2;
	}

	/**
	 * @return the panelCenterNorter_3
	 */
	public JPanel getPanelCenterNorter_3() {
		return panelCenterNorter_3;
	}

	/**
	 * @param panelCenterNorter_3 the panelCenterNorter_3 to set
	 */
	public void setPanelCenterNorter_3(JPanel panelCenterNorter_3) {
		this.panelCenterNorter_3 = panelCenterNorter_3;
	}

	/**
	 * @return the panelNorth
	 */
	public JPanel getPanelNorth() {
		return panelNorth;
	}

	/**
	 * @param panelNorth the panelNorth to set
	 */
	public void setPanelNorth(JPanel panelNorth) {
		this.panelNorth = panelNorth;
	}

	/**
	 * @return the panelSouth
	 */
	public JPanel getPanelSouth() {
		return panelSouth;
	}

	/**
	 * @param panelSouth the panelSouth to set
	 */
	public void setPanelSouth(JPanel panelSouth) {
		this.panelSouth = panelSouth;
	}

	/**
	 * @return the panelWest
	 */
	public JPanel getPanelWest() {
		return panelWest;
	}

	/**
	 * @param panelWest the panelWest to set
	 */
	public void setPanelWest(JPanel panelWest) {
		this.panelWest = panelWest;
	}

	/**
	 * @return the splitNorthCenter
	 */
	public JSplitPane getSplitNorthCenter() {
		return splitNorthCenter;
	}

	/**
	 * @param splitNorthCenter the splitNorthCenter to set
	 */
	public void setSplitNorthCenter(JSplitPane splitNorthCenter) {
		this.splitNorthCenter = splitNorthCenter;
	}

	/**
	 * @return the splitNorthCenterEast
	 */
	public JSplitPane getSplitNorthCenterEast() {
		return splitNorthCenterEast;
	}

	/**
	 * @param splitNorthCenterEast the splitNorthCenterEast to set
	 */
	public void setSplitNorthCenterEast(JSplitPane splitNorthCenterEast) {
		this.splitNorthCenterEast = splitNorthCenterEast;
	}

	/**
	 * @return the splitNorthWestCenter
	 */
	public JSplitPane getSplitNorthWestCenter() {
		return splitNorthWestCenter;
	}

	/**
	 * @param splitNorthWestCenter the splitNorthWestCenter to set
	 */
	public void setSplitNorthWestCenter(JSplitPane splitNorthWestCenter) {
		this.splitNorthWestCenter = splitNorthWestCenter;
	}

	/**
	 * @return the splitWestCenter
	 */
	public JSplitPane getSplitWestCenter() {
		return splitWestCenter;
	}

	/**
	 * @param splitWestCenter the splitWestCenter to set
	 */
	public void setSplitWestCenter(JSplitPane splitWestCenter) {
		this.splitWestCenter = splitWestCenter;
	}

	/**
	 * @return the tabbedCenterCenter
	 */
	public TabbedPanel getTabbedCenterCenter() {
		return tabbedCenterCenter;
	}

	/**
	 * @param tabbedCenterCenter the tabbedCenterCenter to set
	 */
	public void setTabbedCenterCenter(TabbedPanel tabbedCenterCenter) {
		this.tabbedCenterCenter = tabbedCenterCenter;
	}

	/**
	 * @return the tabbedCenterNorth_1
	 */
	public TabbedPanel getTabbedCenterNorth_1() {
		return tabbedCenterNorth_1;
	}

	/**
	 * @param tabbedCenterNorth_1 the tabbedCenterNorth_1 to set
	 */
	public void setTabbedCenterNorth_1(TabbedPanel tabbedCenterNorth_1) {
		this.tabbedCenterNorth_1 = tabbedCenterNorth_1;
	}

	/**
	 * @return the tabbedCenterNorth_2
	 */
	public TabbedPanel getTabbedCenterNorth_2() {
		return tabbedCenterNorth_2;
	}

	/**
	 * @param tabbedCenterNorth_2 the tabbedCenterNorth_2 to set
	 */
	public void setTabbedCenterNorth_2(TabbedPanel tabbedCenterNorth_2) {
		this.tabbedCenterNorth_2 = tabbedCenterNorth_2;
	}

	/**
	 * @return the tabbedCenterNorth_3
	 */
	public TabbedPanel getTabbedCenterNorth_3() {
		return tabbedCenterNorth_3;
	}

	/**
	 * @param tabbedCenterNorth_3 the tabbedCenterNorth_3 to set
	 */
	public void setTabbedCenterNorth_3(TabbedPanel tabbedCenterNorth_3) {
		this.tabbedCenterNorth_3 = tabbedCenterNorth_3;
	}

	/**
	 * @return the tabbedWest
	 */
	public TabbedPanel getTabbedWest() {
		return tabbedWest;
	}

	/**
	 * @param tabbedWest the tabbedWest to set
	 */
	public void setTabbedWest(TabbedPanel tabbedWest) {
		this.tabbedWest = tabbedWest;
	}

	/**
	 * @return the currentProject
	 */
	public String getCurrentProjectFolder() {
		return currentProjectFolder;
	}

	/**
	 * @param currentProject the currentProject to set
	 */
	public void setCurrentProjectFolder(String currentProject) {
		this.currentProjectFolder = currentProject;
	}

	/**
	 * @return the workSpace
	 */
	public String getWorkSpaceFolder() {
		return workSpaceFolder;
	}

	/**
	 * @param workSpace the workSpace to set
	 */
	public void setWorkSpaceFolder(String workSpace) {
		this.workSpaceFolder = workSpace;
	}

	/**
	 * @return the currentProjectJspFolder
	 */
	public String getCurrentProjectJspFolder() {
		return currentProjectJspFolder;
	}

	/**
	 * @param currentProjectJspFolder the currentProjectJspFolder to set
	 */
	public void setCurrentProjectJspFolder(String currentProjectJspFolder) {
		this.currentProjectJspFolder = currentProjectJspFolder;
	}

	/**
	 * @return the currentProjectPlsqlFolder
	 */
	public String getCurrentProjectPlsqlFolder() {
		return currentProjectPlsqlFolder;
	}

	/**
	 * @param currentProjectPlsqlFolder the currentProjectPlsqlFolder to set
	 */
	public void setCurrentProjectPlsqlFolder(String currentProjectPlsqlFolder) {
		this.currentProjectPlsqlFolder = currentProjectPlsqlFolder;
	}
	
	public String getProjectCanonicalFolder(){
		return workSpaceFolder + File.separator + currentProjectFolder;
	}

	/**
	 * @return the menuMap
	 */
	public HashMap<String, Component> getMenuMap() {
		return menuMap;
	}

	/**
	 * @param menuMap the menuMap to set
	 */
	public void setMenuMap(HashMap<String, Component> menuMap) {
		this.menuMap = menuMap;
	}

	/**
	 * @return the toolBarMap
	 */
	public HashMap<String, Component> getToolBarMap() {
		return toolBarMap;
	}

	/**
	 * @param toolBarMap the toolBarMap to set
	 */
	public void setToolBarMap(HashMap<String, Component> toolBarMap) {
		this.toolBarMap = toolBarMap;
	}

	/**
	 * @return the tabTitledMap
	 */
	public HashMap<String, TabComponentInterface> getTabTitledMap() {
		return tabTitledMap;
	}

	/**
	 * @param tabTitledMap the tabTitledMap to set
	 */
	public void setTabTitledMap(HashMap<String, TabComponentInterface> tabTitledMap) {
		this.tabTitledMap = tabTitledMap;
	}
}