/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 6, 2007     Ҳڹ()      Ŭ ó ۼ  
 * Aug 8, 2007     Ҳڹ()       Ͽ   Լ ϳ Լ , Log4j 
 * 
 *************************************************************************
 */

package com.nate.hjy7942.conf.reader;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

/**
 * ۼ : Aug 4, 2007
 * ۼ : Ҳڹ()
 * <br>
 * Properties  о  ü
 */
public class PropertiesReader {
	
	private JFrame mainFrame = null;
	private Properties properties = null;

	/**
	 * Programe Ǵ Properties File о  ü .
	 * @param mainFrame ̰ü ǰ ִ θ Frame
	 */
	public PropertiesReader(JFrame mainFrame){
		this.mainFrame = mainFrame;
		properties = new Properties();
	}
	
	/**
	 * FileName, Key  ش Value ޾ƿ  Լ.
	 * @param fileName Properties  ̸.
	 * @param key ʿ Value  ִ Key.
	 * @return Key  ִ Value.
	 */
	public String getPropertyValue(String fileName, String key) {
		FileInputStream fis = null;
		try{
			fis = new FileInputStream(fileName);
			properties.load(fis);
		}catch(IOException e){
			JOptionPane.showMessageDialog(mainFrame, fileName + "  б  ", "", JOptionPane.ERROR_MESSAGE);
			LoggerReader.getLogger(mainFrame).fatal(fileName + "  б  (" + e.getMessage() + ")");
			System.exit(0);
		}
		
		String Value = properties.getProperty(key).trim();
		
		if(Value == null){
			JOptionPane.showMessageDialog(mainFrame, fileName + " ߸ ", "", JOptionPane.ERROR_MESSAGE);
			LoggerReader.getLogger(mainFrame).fatal(fileName + " Ͽ Ű(" + key + ")   ʽϴ.");
			System.exit(0);
		}
		
		try {
			fis.close();
		} catch (IOException e) {
			LoggerReader.getLogger(mainFrame).warn("Ʈ Close  ʾҽϴ. (" + e.getMessage() + ")");
		}
		
		return Value;
	}
}