/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 6, 2007     Ҳڹ()      Ŭ ó ۼ  
 * Aug 8, 2007     Ҳڹ()       ּ, Log4j   
 * 
 *************************************************************************
 */

package com.nate.hjy7942.conf.reader;

import java.io.IOException;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;


/**
 * ۼ : Aug 4, 2007
 * ۼ : Ҳڹ()
 * <br>
 * XML оͼ NodeList ü ִ ü
 */
public class XmlReader {
	
	private JFrame mainFrame = null;
	
	/**
	 * Xml File о ش Node List ֱ ü .
	 * @param mainFrame ̰ü  θ Frame
	 */
	public XmlReader(JFrame mainFrame){
		this.mainFrame = mainFrame;
	}
	
	/**
	 * MenuBar   ִ XML о NodeListü returnش Լ.
	 * @param fileName ش  ִ XML ̸.
	 * @return XML о   ִ NodeList ü.
	 */
	public NodeList getMenuBarNodeListFromXml(String fileName){
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder dBuilder = null;
		try {
			dBuilder = factory.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			JOptionPane.showMessageDialog(mainFrame, "DocumentBuilder   ", "", JOptionPane.ERROR_MESSAGE);
			LoggerReader.getLogger(mainFrame).fatal("DocumentBuilder   (" + e.getMessage() + ")");
			System.exit(0);
		}
		Document document = null;
		try {
			document = dBuilder.parse(fileName);
		} catch (SAXException e) {
			JOptionPane.showMessageDialog(mainFrame, "SAXException  ߻", "", JOptionPane.ERROR_MESSAGE);
			LoggerReader.getLogger(mainFrame).fatal("SAXException  ߻ (" + e.getMessage() + ")");
			System.exit(0);
		} catch (IOException e) {
			JOptionPane.showMessageDialog(mainFrame, fileName + " б ", "", JOptionPane.ERROR_MESSAGE);
			LoggerReader.getLogger(mainFrame).fatal(fileName + " б  (" + e.getMessage() + ")");
			System.exit(0);
		}
		
		Element rootElement = document.getDocumentElement();
		NodeList nodeList = rootElement.getChildNodes();
		
		return nodeList;
	}
	
	/**
	 * ToolBar   ִ XML о NodeListü returnش Լ.
	 * @param fileName ش  ִ XML ̸.
	 * @return XML о   ִ NodeList ü.
	 */
	public NodeList getToolBarNodeListFromXml(String fileName){
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder dBuilder = null;
		try {
			dBuilder = factory.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			JOptionPane.showMessageDialog(mainFrame, "DocumentBuilder   ", "", JOptionPane.ERROR_MESSAGE);
			LoggerReader.getLogger(mainFrame).fatal("DocumentBuilder   (" + e.getMessage() + ")");
			System.exit(0);
		}
		Document document = null;
		try {
			document = dBuilder.parse(fileName);
		} catch (SAXException e) {
			JOptionPane.showMessageDialog(mainFrame, "SAXException  ߻", "", JOptionPane.ERROR_MESSAGE);
			LoggerReader.getLogger(mainFrame).fatal(fileName + " б  (" + e.getMessage() + ")");
			System.exit(0);
		} catch (IOException e) {
			JOptionPane.showMessageDialog(mainFrame, fileName + " б  ", "", JOptionPane.ERROR_MESSAGE);
			LoggerReader.getLogger(mainFrame).fatal(fileName + " б  (" + e.getMessage() + ")");
			System.exit(0);
		}
		
		Element rootElement = document.getDocumentElement();
		NodeList nodeList = rootElement.getChildNodes();
		
		return nodeList;
	}
}
