/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 6, 2007     Ҳڹ()      Ŭ ó ۼ  
 * Aug 8, 2007     Ҳڹ()       Ͽ   Լ ϳ Լ , Log4j 
 * 
 *************************************************************************
 */

package com.nate.hjy7942.conf.writer;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import com.nate.hjy7942.conf.reader.LoggerReader;

/**
 * ۼ : Aug 4, 2007
 * ۼ : Ҳڹ()
 * <br>
 * Properties Ͽ   ü
 */
public class PropertiesWriter {
	
	private JFrame mainFrame = null;
	private Properties properties = null;

	/**
	 * Programe Ǵ Properties File  ϱ  ü.
	 * @param mainFrame ̰ü ǰ ִ θ Frame
	 */
	public PropertiesWriter(JFrame mainFrame){
		this.mainFrame = mainFrame;
		properties = new Properties();
	}
	
	/**
	 * FileName, Key, Value  ش Ͽ Key Value .
	 * @param fileName Properties  ̸.
	 * @param key ʿ Value  ִ Key.
	 * @param value شϴ key  Ͱ.
	 */
	public void replacePropertyValue(String fileName, String key, String value) {
		FileInputStream fis = null;
		try{
			fis = new FileInputStream(fileName);
			properties.load(new BufferedInputStream(fis));
			properties.setProperty(key, value);
			properties.store(new FileOutputStream(fileName), "");
			fis.close();
		}catch(IOException e){
			JOptionPane.showMessageDialog(mainFrame, fileName + "    ", "", JOptionPane.ERROR_MESSAGE);
			LoggerReader.getLogger(mainFrame).fatal(fileName + "    (" + e.getMessage() + ")");
			System.exit(0);
		}
	}
}