/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Sep 21, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.conf.writer;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * ۼ : Sep 21, 2007
 * ۼ : Ҳڹ 
 * <br>
 *  ־ ּ!!
 */
public class XmlWriter {
	
	private XmlWriter() { }
	
	/**
	 * XmlϿ ٲٰ   Ӽ Ҽ ִ.
	 * static Լ  Ǿ, ϰ  Ŭ ̸ Ͽ 𼭳  ϴ.
	 * XmlWriter.writeDataToXml() Լ ȣϸ ǰ, ˸ ڸ  ȴ.
	 * 
	 * @param fileName xml ̸
	 * @param nodeName xml ˻ node̸
	 * @param nodeAtrName nodeӿ ãϴ Ӽ̸.
	 * @param nodeAtrValue nodeӿ ãϴ Ӽ
	 * @param replaceNodeAtr node üϰ  Ӽ̸.
	 * @param replaceNodeValue node üϰ  ۼ.
	 */
	public static void writeDataToXml(String fileName, String nodeName, String nodeAtrName, String nodeAtrValue, String replaceNodeAtr, String replaceNodeValue) {
		
		try {
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			factory.setIgnoringElementContentWhitespace(true);
			DocumentBuilder dBuilder = factory.newDocumentBuilder();
			Document document = dBuilder.parse(fileName);
			Element rootElement = document.getDocumentElement();
			
			NodeList nodeList = rootElement.getChildNodes();
			Node replaceNode = findNode(nodeList, nodeName, nodeAtrName, nodeAtrValue);
			replaceNode.getAttributes().getNamedItem(replaceNodeAtr).setNodeValue(replaceNodeValue);
			
			TransformerFactory tFactory = TransformerFactory.newInstance();
			Transformer transformer = tFactory.newTransformer();
			DOMSource domSource = new DOMSource(document);
			StreamResult streamResult = new StreamResult(fileName);
			transformer.transform(domSource, streamResult);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private static Node findNode(NodeList nodeList, String nodeName, String nodeAtrName, String nodeAtrValue){
		Node returnNode = null;
		
		for(int i = 0; i < nodeList.getLength(); i++) {
			Node tempNode = nodeList.item(i);
			
			if(tempNode.getNodeName().equals("#text") || !(tempNode.getNodeName().equals(nodeName))) {
				continue;
			}
			
			if(nodeAtrValue.equals(tempNode.getAttributes().getNamedItem(nodeAtrName).getNodeValue())) {
				returnNode = tempNode;
				break;
			}
			
			if(tempNode.hasChildNodes()) {
				findNode(tempNode.getChildNodes(), nodeName, nodeAtrName, nodeAtrValue);
			}
		}
		
		return returnNode;
	}
}
