package com.nate.hjy7942.demon;

import javax.swing.JProgressBar;

public class ProgressThread extends JProgressBar implements Runnable{
	
	private static int progressValue = 0;
	
	public ProgressThread() {
		super();
		
		this.setBounds(0, 330, 500, 20);
		this.setMinimum(0);
		this.setMaximum(100);
		this.setValue(0);
		
	}
	
	public void run() {
		for(; progressValue < this.getMaximum(); progressValue++){
			setProgressValue(progressValue);
			this.setValue(progressValue);
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {}
		}
	}
	
	public static synchronized void setProgressValue(int value){
		ProgressThread.progressValue = value;
	}
}
