/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 13, 2007     Ҳڹ                     Ŭ ó ۼ  
 * 
 *************************************************************************
 */
package com.nate.hjy7942.ui.dialog;

import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileSystemView;
import javax.swing.filechooser.FileView;

import com.nate.hjy7942.conf.manager.MainFrame;

/**
 * ۼ : 2007. 08. 29 
 * ۼ : Ҳڹ  
 * <br> 
 * static  Ͽ, FileChooserü ׻  ϰ , ʿÿ ü  ޾Ƽ  Ҽ ְ .
 * Singleton  Ͽ, ܺο ü  Ұϸ, ϰ ϳ ü   Ҽ .
 */
public class FileSaveDialog {
	
	private static FileSaveDialog saveDialog= new FileSaveDialog();
	private static MainFrame mainFrame = null;
	private static JFileChooser chooser = null;
	
	private FileSaveDialog() {}
	
	/**
	 * FileSaveDialog   ִ.
	 * 
	 * @param mainFrame FileSaveDialog θ Dialog
	 * @param path FileSaveDialog  Ե 
	 * @return  JFileChooser  .
	 */
	public static JFileChooser getFileSaveDialog(MainFrame mainFrame, String path){
		if(chooser == null){
			chooser = new JFileChooser(FileSystemView.getFileSystemView());
			FileFilter type1 = new ExtensionFilter("PL/SQL files (*.sql)", ".sql");
			FileFilter type2 = new ExtensionFilter("Java Stored Procedure files (*.java)", ".java");
			chooser.addChoosableFileFilter(type1);
			chooser.addChoosableFileFilter(type2);
			chooser.setFileFilter(type1); 
			FileView view = new IconView();
			chooser.setFileView(view);
		}
		
		FileSaveDialog.mainFrame = mainFrame;
		chooser.setCurrentDirectory(new File(path));
		return chooser;
	}
}
