/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 13, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */
package com.nate.hjy7942.ui.dialog;

import java.io.File;
import java.util.HashMap;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.filechooser.FileSystemView;
import javax.swing.filechooser.FileView;

import com.nate.hjy7942.util.ResourceHandler;

/**
 * ۼ : 2007. 08. 29 
 * ۼ : Ҳڹ  
 * <br> 
 * FileView Class  ޾. JFileChooser Ե ϵ  ǥϱ  .
 */
public class IconView extends FileView {
	private HashMap<String, ImageIcon> hash = new HashMap<String, ImageIcon>();
	private FileSystemView fs = FileSystemView.getFileSystemView();

	public IconView() {
		hash.put("java", ResourceHandler.createImageIcon("filechooser_java.png"));
		hash.put("sql", ResourceHandler.createImageIcon("filechooser_plsql.png"));
	}

	public String getName(File f) {
		String s = fs.getSystemDisplayName(f);
		if (s.length() == 0) {
			s = f.getAbsolutePath();
		}
		return s;
	}

	public String getDescription(File f) {
		return fs.getSystemDisplayName(f);
	}

	public String getTypeDescription(File f) {
		return f.getAbsolutePath();
	}

	public Icon getIcon(File f) {
		String path = f.getAbsolutePath();
		int pos = path.lastIndexOf('.');
		if ((pos >= 0) && (pos < (path.length() - 1))) {
			String ext = path.substring(pos + 1).toLowerCase();
			return (Icon) hash.get(ext);
		}
    	return null;
	}

	public Boolean isTraversable(File file) {
		return (new Boolean(file.isDirectory()));
	}
}