/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Sep 7, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.dialog;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.border.BevelBorder;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.filechooser.FileSystemView;

import com.nate.hjy7942.ui.filesystemtree.FileSystemTreeModel;
import com.nate.hjy7942.ui.filesystemtree.FileSystemTreeNode;
import com.nate.hjy7942.ui.filesystemtree.FileSystemTreeRenderer;
import com.nate.hjy7942.util.SystemProperties;

/**
 * ۼ : Sep 7, 2007
 * ۼ : Ҳڹ 
 * <br>
 *  ־ ּ!!
 */
public class SelectWorkspaceDirectoryDialog extends JDialog{
	
	private JDialog curDialog;
	private JTree tree;
	private JTextField textField;
	private static String returnText;
	private FileSystemView fs = FileSystemView.getFileSystemView();
	
	private SelectWorkspaceDirectoryDialog(Container parentDialog) {
		super((JDialog) parentDialog, true);
		this.curDialog = this;
		setResizable(false);
		getContentPane().setLayout(null);
		setTitle("Select Workspace Directory");
		setSize(380, 360);
		setLocation(SystemProperties.getCenterPoint(this));
		
		final JLabel selectTheWorkspaceLabel = new JLabel();
		selectTheWorkspaceLabel.setText("Select the workspace directory to use");
		selectTheWorkspaceLabel.setBounds(10, 10, 257, 15);
		getContentPane().add(selectTheWorkspaceLabel);

		final JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		panel.setBorder(new BevelBorder(BevelBorder.LOWERED));
		panel.setBackground(Color.WHITE);
		panel.setBounds(10, 40, 352, 207);
		getContentPane().add(panel);

		tree = new JTree();
		File rootFile = (fs.getRoots())[0];
		tree.setCellRenderer(new FileSystemTreeRenderer());
		tree.setModel(new FileSystemTreeModel(rootFile, FileSystemTreeModel.ONLYDIRECTORY));
		tree.addTreeSelectionListener(new TreeSelectionListener() {
			public void valueChanged(TreeSelectionEvent e) {
				JTree tree = (JTree) e.getSource();
				FileSystemTreeNode node = (FileSystemTreeNode) tree.getLastSelectedPathComponent();
				if(node == null){
					return;
				}
				textField.setText(fs.getSystemDisplayName(node.getFile()));
				
				try {
					returnText = node.getFile().getCanonicalPath();
				} catch (IOException e1) {}
			}
		});
		panel.add(new JScrollPane(tree), BorderLayout.CENTER);

		final JLabel folderLabel = new JLabel();
		folderLabel.setText("Folder  : ");
		folderLabel.setBounds(10, 265, 67, 15);
		getContentPane().add(folderLabel);

		textField = new JTextField();
		textField.setEditable(false);
		textField.setBounds(74, 262, 288, 21);
		getContentPane().add(textField);

		final JButton cancelButton = new JButton();
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				returnText = null;
				setVisible(false);
			}
		});
		cancelButton.setText("Cancel");
		cancelButton.setBounds(280, 295, 80, 23);
		getContentPane().add(cancelButton);

		final JButton okButton = new JButton();
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
			}
		});
		okButton.setText("OK");
		okButton.setBounds(188, 295, 80, 23);
		getContentPane().add(okButton);

		final JButton newFolderButton = new JButton();
		newFolderButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String folderName = JOptionPane.showInputDialog(curDialog, " ̸ Էּ.", "Է", JOptionPane.INFORMATION_MESSAGE);
				if(folderName != null || folderName.trim() != ""){
					File newFileDirectory = new File(returnText + "/" + folderName);
					if(newFileDirectory.mkdir()){
						try {
							returnText = newFileDirectory.getCanonicalPath();
							setVisible(false);
						} catch (IOException e1) {
							e1.printStackTrace();
						}
					}
					else{
						JOptionPane.showMessageDialog(curDialog, folderName + " ̸   ϴ.", "", JOptionPane.ERROR_MESSAGE);
					}
				}
			}
		});
		newFolderButton.setText("New Folder");
		newFolderButton.setBounds(10, 295, 103, 23);
		getContentPane().add(newFolderButton);
	}
	
	public static String showDialog(Container parentDialog){
		new SelectWorkspaceDirectoryDialog(parentDialog).setVisible(true);
		return returnText;
	}
}
