/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 26, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.maker;

import java.awt.BorderLayout;
import java.awt.Insets;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.border.EmptyBorder;

import net.infonode.tabbedpanel.TabDropDownListVisiblePolicy;
import net.infonode.tabbedpanel.TabbedPanel;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.ui.tabicon.TabbedCenterCenterCloseAllIconButton;
import com.nate.hjy7942.ui.tabicon.TabbedCenterCenterCloseIconButton;
import com.nate.hjy7942.ui.tabicon.TabbedCenterCenterConvertorButton;
import com.nate.hjy7942.ui.tabicon.TabbedCenterCenterPrintIconButton;
import com.nate.hjy7942.ui.tabicon.TabbedCenterCenterSaveIconAllButton;
import com.nate.hjy7942.ui.tabicon.TabbedCenterCenterSaveIconButton;
import com.nate.hjy7942.ui.tabmodule.listener.TabbedCenterCenterTabListener;
import com.nate.hjy7942.util.ResourceHandler;

/**
 * ۼ : Aug 26, 2007
 * ۼ : Ҳڹ 
 * <br>
 * ȭ Layout ,   JPanel ߰ Ѵ.
 * ׸ JPanel TabbedPanel ߰Ͽ Tab  ְ  ش.
 */
public class FrameLayoutMaker {
	
	private MainFrame mainFrame = null;
	
	public FrameLayoutMaker(MainFrame mainFrame){
		this.mainFrame = mainFrame;
	}
	
	/**
	 * ȭ Layout ,   JPanel ߰ Ѵ.
	 * ׸ JPanel TabbedPanel ߰Ͽ Tab  ְ  ش.
	 */
	public void makeLayout(){
		JPanel westPanel = new JPanel(new BorderLayout());
		JPanel centerPanel = new JPanel(new BorderLayout());
		
		final JSplitPane splitPane_WestCenter = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, true, westPanel, centerPanel);
		splitPane_WestCenter.setDividerSize(2);
		splitPane_WestCenter.setDividerLocation(280);
		mainFrame.getContentPane().add(splitPane_WestCenter, BorderLayout.CENTER);

		JPanel centerNorthtPanel = new JPanel(new BorderLayout());
		JPanel centerCenterPanel = new JPanel(new BorderLayout());
		
		final JSplitPane splitPane_CenterNorthCenter = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true, centerNorthtPanel, centerCenterPanel);
		splitPane_CenterNorthCenter.setDividerSize(2);
		splitPane_CenterNorthCenter.setDividerLocation(280);
		centerPanel.add(splitPane_CenterNorthCenter, BorderLayout.CENTER);	
		
		JPanel centerNorthtWestPanel = new JPanel(new BorderLayout());
		JPanel centerCenterCenterPanel = new JPanel(new BorderLayout());
		
		final JSplitPane splitPane_CenterNorthWestCenter = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, true, centerNorthtWestPanel, centerCenterCenterPanel);
		splitPane_CenterNorthWestCenter.setDividerSize(2);
		splitPane_CenterNorthWestCenter.setResizeWeight(0.33);
		centerNorthtPanel.add(splitPane_CenterNorthWestCenter, BorderLayout.CENTER);
		
		JPanel centerNorthtCenterCenterPanel = new JPanel(new BorderLayout());
		JPanel centerCenterCenterEastPanel = new JPanel(new BorderLayout());
		
		final JSplitPane splitPane_CenterNorthCenterEast = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, true, centerNorthtCenterCenterPanel, centerCenterCenterEastPanel);
		splitPane_CenterNorthCenterEast.setDividerSize(2);
		splitPane_CenterNorthCenterEast.setResizeWeight(0.50);
		centerCenterCenterPanel.add(splitPane_CenterNorthCenterEast, BorderLayout.CENTER);
		
		TabbedPanel tabbed_Westl = new TabbedPanel();
		tabbed_Westl.getProperties().getContentPanelProperties().getComponentProperties().setInsets(new Insets(3, 3, 3, 3));
		westPanel.add(tabbed_Westl, BorderLayout.CENTER);
		TabbedPanel tabbed_CenterNorth_1 = new TabbedPanel();
		tabbed_CenterNorth_1.getProperties().getContentPanelProperties().getComponentProperties().setInsets(new Insets(3, 3, 3, 3));
		centerNorthtWestPanel.add(tabbed_CenterNorth_1, BorderLayout.CENTER);
		TabbedPanel tabbed_CenterNorth_2 = new TabbedPanel();
		tabbed_CenterNorth_2.getProperties().getContentPanelProperties().getComponentProperties().setInsets(new Insets(3, 3, 3, 3));
		centerNorthtCenterCenterPanel.add(tabbed_CenterNorth_2, BorderLayout.CENTER);
		TabbedPanel tabbed_CenterNorth_3 = new TabbedPanel();
		tabbed_CenterNorth_3.getProperties().getContentPanelProperties().getComponentProperties().setInsets(new Insets(3, 3, 3, 3));
		centerCenterCenterEastPanel.add(tabbed_CenterNorth_3, BorderLayout.CENTER);
		TabbedPanel tabbed_CenterCenter = new TabbedPanel();
		tabbed_CenterCenter.getProperties().setTabDropDownListVisiblePolicy(TabDropDownListVisiblePolicy.MORE_THAN_ONE_TAB);
		JComponent[] CenterCenterIconButton = {
				new TabbedCenterCenterSaveIconButton(), 
				new TabbedCenterCenterSaveIconAllButton(), 
				new JLabel(ResourceHandler.createImageIcon("statebar.png")),
				new TabbedCenterCenterCloseIconButton(),
				new TabbedCenterCenterCloseAllIconButton(), 
				new JLabel(ResourceHandler.createImageIcon("statebar.png")),
				new TabbedCenterCenterConvertorButton(),
				new JLabel(ResourceHandler.createImageIcon("statebar.png")),
				new TabbedCenterCenterPrintIconButton()};
		tabbed_CenterCenter.setTabAreaComponents(CenterCenterIconButton);
		tabbed_CenterCenter.getProperties().getContentPanelProperties().getComponentProperties().setInsets(new Insets(3, 3, 3, 3));
		tabbed_CenterCenter.addTabListener(TabbedCenterCenterTabListener.getInstance(mainFrame));
		centerCenterPanel.add(tabbed_CenterCenter, BorderLayout.CENTER);
		
		westPanel.setBorder(new EmptyBorder(3, 3, 0, 3));
		centerCenterPanel.setBorder(new EmptyBorder(3, 3, 0, 3));
		centerNorthtWestPanel.setBorder(new EmptyBorder(3, 3, 3, 3));
		centerNorthtCenterCenterPanel.setBorder(new EmptyBorder(3, 3, 3, 3));
		centerCenterCenterEastPanel.setBorder(new EmptyBorder(3, 3, 3, 3));
		
		splitPane_CenterNorthCenter.setBorder(null);
		splitPane_CenterNorthWestCenter.setBorder(null);
		splitPane_CenterNorthCenterEast.setBorder(null);
		
		mainFrame.setSplitWestCenter(splitPane_WestCenter);
		mainFrame.setSplitNorthCenter(splitPane_CenterNorthCenter);
		mainFrame.setSplitNorthWestCenter(splitPane_CenterNorthWestCenter);
		mainFrame.setSplitNorthCenterEast(splitPane_CenterNorthCenterEast);
		
		mainFrame.setPanelWest(westPanel);
		mainFrame.setPanelCenterCenter(centerCenterPanel);
		mainFrame.setPanelCenterNorter_1(centerNorthtWestPanel);
		mainFrame.setPanelCenterNorter_2(centerNorthtCenterCenterPanel);
		mainFrame.setPanelCenterNorter_3(centerCenterCenterEastPanel);
		
		mainFrame.setTabbedWest(tabbed_Westl);
		mainFrame.setTabbedCenterCenter(tabbed_CenterCenter);
		mainFrame.setTabbedCenterNorth_1(tabbed_CenterNorth_1);
		mainFrame.setTabbedCenterNorth_2(tabbed_CenterNorth_2);
		mainFrame.setTabbedCenterNorth_3(tabbed_CenterNorth_3);
	}
}
