/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 15, 2007  Ҳڹ()   Ŭ ó ۼ  
 * 
 *************************************************************************
 */
package com.nate.hjy7942.ui.maker;

import java.awt.Component;
import java.awt.event.ActionListener;

import javax.swing.JMenu;
import javax.swing.JMenuItem;

import com.nate.hjy7942.conf.manager.MainFrame;

/**
 * ۼ : Aug 12, 2007
 * ۼ : Ҳڹ() 
 * <br>
 * JMenuIem ӹ Class̰,  ڸ ޾Ƽ ޴۰ü .
 */
public class MenuCreator {
	
	private MenuCreator() {}
	
	public static Component getMenu(MainFrame mainFrame, String menuName){
		
		Component temp = mainFrame.getMenuMap().get(menuName);
		Component cloneComponent = null;
		
		if (temp instanceof JMenu) {
			JMenu menu = (JMenu) temp;
			JMenu cloneMenu = new JMenu();
			createMenu(menu, cloneMenu);
			cloneComponent = cloneMenu;
		}
		else if (temp instanceof JMenuItem) {
			JMenuItem menuItem = (JMenuItem) temp;	
			
			cloneComponent =  createMenuItem(menuItem);
		}
		
		return cloneComponent;
	}
	
	private static Component createMenuItem(JMenuItem menuItem){
		JMenuItem cloneItem = new JMenuItem(); 

		ActionListener[] ac = menuItem.getActionListeners();
		for(int i = 0; i < ac.length; i++){
			try {
				cloneItem.addActionListener(ac[i]);
			} catch (Exception e) {
				System.out.println(e);
			}
		}
		cloneItem.setName(menuItem.getName());
		cloneItem.setText(menuItem.getText());
		cloneItem.setToolTipText(menuItem.getToolTipText());
		cloneItem.setIcon(menuItem.getIcon());

		return cloneItem;
	}
	
	private static void createMenu(JMenu originalMenu, JMenu cloneMenu){
		cloneMenu.setName(originalMenu.getName());
		cloneMenu.setText(originalMenu.getText());
		cloneMenu.setToolTipText(originalMenu.getToolTipText());
		cloneMenu.setIcon(originalMenu.getIcon());
		
		for(int i = 0; i < originalMenu.getItemCount(); i++){
			if(originalMenu.getItem(i) instanceof JMenu){
				JMenu tempCloneMenu = new JMenu();
				createMenu((JMenu) originalMenu.getItem(i), tempCloneMenu);
				cloneMenu.add(tempCloneMenu);
			}
			else if(originalMenu.getItem(i) instanceof JMenuItem){
				cloneMenu.add(createMenuItem(originalMenu.getItem(i)));
			}
			else{
				cloneMenu.addSeparator();
			}
		}
	}
}
