/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 13, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.menu;

import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.conf.reader.FontReader;
import com.nate.hjy7942.util.ResourceHandler;

/**
 * ۼ : Aug 13, 2007
 * ۼ : Ҳڹ 
 * <br>
 * α׷ Ǵ  JMenuItem  Ŭ  ޾Ƽ ϰ ȴ.
 * ⺻ JMenuItem κ ڷ ޾ƿͼ JMenuItem .
 */

public abstract class AbstractMenuItem extends JMenuItem{

	protected MainFrame mainFrame;	
	
	/**
	 * JMenuItem ⺻  XMLϿ о  ޾ .
	 * @param mainFrame mainFrame MainFrame ü
	 * @param nameItem JMenu ̸
	 * @param captionItem JMenu 
	 * @param accelerator JMenuItem Ű
	 * @param icon JMenuItem տ   
	 */
	public AbstractMenuItem(MainFrame mainFrame, String menuName, String name, String caption, String accelerator, String icon){
		this.mainFrame = mainFrame;
		if(menuName != null){
			this.setName(menuName);
		}
		if(name != null){
			this.setText("  " + name + " ");
		}
		if(caption != null){
			this.setToolTipText(caption);
		}
		if(accelerator != null){
			this.setAccelerator(KeyStroke.getKeyStroke(accelerator));
		}
		if(icon != null){
			this.setIcon(ResourceHandler.createImageIcon(icon));
		}
		this.setFont(FontReader.getMenuItemFont(mainFrame));
	}
}
