/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Sep 23, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.menu;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JMenuItem;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.conf.reader.PropertiesReader;
import com.nate.hjy7942.conf.writer.PropertiesWriter;
import com.nate.hjy7942.ui.tabmodule.inter.TabComponentInterface;
import com.nate.hjy7942.util.ResourceHandler;

/**
 * ۼ : Sep 23, 2007
 * ۼ : Ҳڹ 
 * <br>
 *  ־ ּ!!
 */


public class ViewMenuItem extends JMenuItem implements ActionListener{
	
	private MainFrame mainFrame = null;
	private boolean flag;
	private ImageIcon img = null;
	private TabComponentInterface tabComponent = null;
	
	public ViewMenuItem(MainFrame mainFrame, TabComponentInterface tabComponent, ImageIcon img, boolean flag ){
		super(tabComponent.getTabTitle());
		this.mainFrame = mainFrame;
		this.tabComponent = tabComponent;
		this.img = img;
		this.flag = flag;
		if(flag) {
			this.setIcon(img);
		}
		
		this.addActionListener(this);
	}

	public void actionPerformed(ActionEvent e) {
		if(flag) {
			flag = false;
			this.setIcon(null);
			String xmlToolBarFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "frameFile");
			new PropertiesWriter(mainFrame).replacePropertyValue(xmlToolBarFileName, this.getText() + "View", "false");
			tabComponent.getTabbedPanel().removeTab(tabComponent.getTitledTab());
		}
		else {
			flag = true;
			this.setIcon(img);
			String xmlToolBarFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "frameFile");
			new PropertiesWriter(mainFrame).replacePropertyValue(xmlToolBarFileName, this.getText() + "View", "true");
			tabComponent.getTabbedPanel().addTab(tabComponent.getTitledTab());
		}
	}
}
