/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 28, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.menu.listener;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.FileReader;

import javax.swing.JFileChooser;
import javax.swing.JScrollPane;

import net.infonode.tabbedpanel.titledtab.TitledTab;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.ui.dialog.FileOpenDialog;
import com.nate.hjy7942.ui.tabmodule.workviewer.PlsqlViewerTabComponent;
import com.nate.hjy7942.ui.tabmodule.workviewer.TextPaneComponent;

/**
 * ۼ : Aug 28, 2007
 * ۼ : Ҳڹ 
 * <br>
 * FileOpen MenuItem ̺Ʈ  ֱ ü.
 * ̱ ü , getInstance()Լ ؼ ü   ִ.
 */
public class FileOpenListener implements ActionListener{
	
	private static FileOpenListener object = new FileOpenListener();
	private static MainFrame mainFrame = null;
	
	private FileOpenListener() {}
	
	/**
	 *  ü ֱ Լ.
	 * @param mainFrame  ü Ǿ θ Dialog.
	 * @return static ü FileOpenListener .
	 */
	public static FileOpenListener getInstance(MainFrame mainFrame){
		FileOpenListener.mainFrame = mainFrame;
		return object;
	}

	public void actionPerformed(ActionEvent e) {
		JFileChooser chooser = FileOpenDialog.getFileOpenDialog(mainFrame, mainFrame.getProjectCanonicalFolder());
		int status = chooser.showOpenDialog(mainFrame);
		System.out.println(chooser.getSelectedFile());
		if (status == JFileChooser.APPROVE_OPTION) {
			TitledTab titledTab = new PlsqlViewerTabComponent(mainFrame).getTitledTab();
			mainFrame.getTabbedCenterCenter().addTab(titledTab);
			mainFrame.getTabbedCenterCenter().setSelectedTab(titledTab);

			JScrollPane scrollPane = (JScrollPane) titledTab.getContentComponent();
			TextPaneComponent textPane = (TextPaneComponent) scrollPane.getViewport().getView();
			
			try{
				FileReader fileReader = new FileReader(chooser.getSelectedFile());
				BufferedReader bufferedReader = new BufferedReader(fileReader);
				
				StringBuffer stringBuffer = new StringBuffer();
				String temp = "";
				while((temp=bufferedReader.readLine()) != null){
					stringBuffer.append(temp+"\n");
				}
				textPane.setText(stringBuffer.toString());
				fileReader.close();
			}catch(Exception ex2){
				
			}
		}
	}
}
