/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 28, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.menu.listener;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JFileChooser;
import javax.swing.JScrollPane;

import net.infonode.tabbedpanel.titledtab.TitledTab;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.ui.dialog.ExtensionFilter;
import com.nate.hjy7942.ui.dialog.FileSaveDialog;
import com.nate.hjy7942.ui.tabmodule.workviewer.TextPaneComponent;

/**
 * ۼ : Aug 28, 2007
 * ۼ : Ҳڹ 
 * <br>
 * FileSave MenuItem ̺Ʈ  ֱ ü.
 * ̱ ü , getInstance()Լ ؼ ü   ִ.
 */
public class FileSaveListener implements ActionListener{
	
	private static FileSaveListener object = new FileSaveListener();
	private static MainFrame mainFrame = null;
	
	private FileSaveListener() {}
	
	/**
	 *  ü ֱ Լ.
	 * @param mainFrame  ü Ǿ θ Dialog.
	 * @return static ü FileSaveListener .
	 */
	public static FileSaveListener getInstance(MainFrame mainFrame){
		FileSaveListener.mainFrame = mainFrame;
		return object;
	}
	
	public void actionPerformed(ActionEvent e) {
		JFileChooser chooser = FileSaveDialog.getFileSaveDialog(mainFrame, mainFrame.getProjectCanonicalFolder());
		int status = chooser.showSaveDialog(mainFrame);

		if (status == JFileChooser.APPROVE_OPTION) {
			TitledTab titleTab = (TitledTab) mainFrame.getTabbedCenterCenter().getSelectedTab();
			if(titleTab != null){
				JScrollPane scrollPane = (JScrollPane) titleTab.getContentComponent();
				TextPaneComponent textPane = (TextPaneComponent) scrollPane.getViewport().getView();

//				if(chooser.getFileFilter() instanceof ExtensionFilter){
//					System.out.println(f + ((ExtensionFilter) chooser.getFileFilter()).getExtensions());
//				}
				
				try {
					FileWriter fileWriter = new FileWriter(chooser.getSelectedFile());

					fileWriter.write(textPane.getText(), 0, (textPane.getText()).length());
					fileWriter.flush();
					fileWriter.close();
				} catch (IOException e1) {
					e1.printStackTrace();
				}
				
				titleTab.setText(textPane.getFileName());
				textPane.setModify(false);
				textPane.setStateBar();
			}
		}
	}
}
