/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Sep 2, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.tabmodule.workviewer;

import javax.swing.JTextPane;

import com.nate.hjy7942.conf.manager.MainFrame;

/**
 * ۼ : Sep 2, 2007
 * ۼ : Ҳڹ 
 * <br>
 * JTextPane ӹ޾ α׷ ð .
 */
public class TextPaneComponent extends JTextPane{
	
	private MainFrame mainFrame = null;
	
	private String currentInsert = null;
	private String currentAble = null;
	private String currentEncording = null;
	private int lines = 0;
	private int caret = 0;
	
	private String fileName = null;
	private boolean modify = false;
	
	public TextPaneComponent(MainFrame mainFrame,  String currentInsert, 
			String currentAble, 	String currentEncording, String fileName){
		this.mainFrame = mainFrame;
		this.currentInsert = currentInsert;
		this.currentAble = currentAble;
		this.currentEncording = currentEncording;
		this.fileName = fileName;
		
		this.addCaretListener(new TextPaneComponentCaretListener(mainFrame, this));
		this.addKeyListener(new TextPaneComponentKeyListener(mainFrame, this));
		this.setStateBar();
	}
	
	public void setStateBar(){
		mainFrame.getCurrentStateInsertField().setText(currentInsert);
		mainFrame.getCurrentStateAbleField().setText(currentAble);
		mainFrame.getCurrentStateCursorLocField().setText(String.valueOf(lines + " : " + caret));
		mainFrame.getCurrentStateEncordingField().setText(currentEncording);
	}

	/**
	 * @return the currentAble
	 */
	public String getCurrentAble() {
		return currentAble;
	}

	/**
	 * @param currentAble the currentAble to set
	 */
	public void setCurrentAble(String currentAble) {
		this.currentAble = currentAble;
	}

	/**
	 * @return the currentEncording
	 */
	public String getCurrentEncording() {
		return currentEncording;
	}

	/**
	 * @param currentEncording the currentEncording to set
	 */
	public void setCurrentEncording(String currentEncording) {
		this.currentEncording = currentEncording;
	}

	/**
	 * @return the currentInsert
	 */
	public String getCurrentInsert() {
		return currentInsert;
	}

	/**
	 * @param currentInsert the currentInsert to set
	 */
	public void setCurrentInsert(String currentInsert) {
		this.currentInsert = currentInsert;
	}

	/**
	 * @return the fileName
	 */
	public String getFileName() {
		return fileName;
	}

	/**
	 * @param fileName the fileName to set
	 */
	public void setFileName(String fileName) {
		this.fileName = fileName;
	}

	/**
	 * @return the modify
	 */
	public boolean isModify() {
		return modify;
	}

	/**
	 * @param modify the modify to set
	 */
	public void setModify(boolean modify) {
		this.modify = modify;
	}

	/**
	 * @return the caret
	 */
	public int getCaretCount() {
		return caret;
	}

	/**
	 * @param caret the caret to set
	 */
	public void setCaretCount(int caret) {
		this.caret = caret;
	}

	/**
	 * @return the lines
	 */
	public int getLines() {
		return lines;
	}

	/**
	 * @param lines the lines to set
	 */
	public void setLines(int lines) {
		this.lines = lines;
	}
}
