/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ****************************
 *                             
 * [¥]         [۾]             []
 * 2007. 08. 31   Ҳڹ          Ŭ ó ۼ  
 * 
 ********************************************************************
 */

package com.nate.hjy7942.util;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * ۼ : 2007. 08. 31
 * ۼ : Ҳڹ 
 * <br>
 *  ־ ּ!!
 */
class JavaCCTokenStringGenerator {

	public static void main(String[] args) throws IOException {
		// convertJavaCCTokenString("plsql_keywords.txt");
		
		
	}

	/**
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	private static void convertJavaCCTokenString(String fileName) throws FileNotFoundException,
			IOException {
		final String PATH = "data" + File.separator; 
		FileReader fr = new FileReader(PATH + fileName);
		BufferedReader br = new BufferedReader(fr);
		FileWriter fw = new FileWriter(PATH + "result_" + fileName);
		BufferedWriter bw = new BufferedWriter(fw);
		String temp = null, lineString;
		
		bw.write("TOKEN : \n");
		bw.write("{\n");
		lineString = br.readLine();
		// System.out.println("  " + makeJavaCCTokenString(lineString));
		bw.write("  " + makeJavaCCTokenString(lineString));
		
		while((lineString = br.readLine()) != null) {
			// System.out.println("| " + makeJavaCCTokenString(lineString));
			bw.write("| " + makeJavaCCTokenString(lineString));
		}
		bw.write("}\n");
		br.close();
		bw.close();
		System.out.println("convertJavaCCTokenString method finished!");
	}
	
	private static String makeJavaCCTokenString(String reservedWord) {
		String result = "< " + reservedWord;
		result = result + ": \"" + reservedWord.toLowerCase() +"\"";  
		result += " >\n";
		return result;
		
	}

	
	
	/**
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	private static void replaceCommaToEnter(String fileName) throws FileNotFoundException,
			IOException {
		final String PATH = "data" + File.separator; 
		FileReader fr = new FileReader(PATH + fileName);
		BufferedReader br = new BufferedReader(fr);
		FileWriter fw = new FileWriter(PATH + "result_" + fileName);
		BufferedWriter bw = new BufferedWriter(fw);
		String temp = null;
		while((temp = br.readLine()) != null) {
			String newTemp = temp.replaceAll(", ", "\n");
			bw.write(newTemp);
		}
		
		System.out.println("replaceCommaToEnter method finished!");
		br.close();
		bw.close();
	}
	
	
	
}
