/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ****************************
 *                             
 * [¥]         [۾]             []
 * 2007. 09. 08   Ҳڹ          Ŭ ó ۼ  
 * 
 ********************************************************************
 */

package com.nate.hjy7942.ui.filesystemtree;

import java.awt.Component;
import java.io.File;

import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;

import com.nate.hjy7942.util.ResourceHandler;

/**
 * ۼ : 2007. 09. 08
 * ۼ : Ҳڹ 
 * <br>
 * Connection Tree    ϴ Ŭ
 */
public class FileSystemTreeRenderer extends DefaultTreeCellRenderer {

	@Override
	public Component getTreeCellRendererComponent(JTree tree, Object value,
			boolean sel, boolean expanded, boolean leaf, int row,
			boolean hasFocus) {
		
		super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf,
				row, hasFocus);
		
		if(value instanceof FileSystemTreeNode) {
			FileSystemTreeNode node = (FileSystemTreeNode) value;
			File file = node.getFile();
			
			if(file.isDirectory()){
				if(expanded){
					setIcon(ResourceHandler.createImageIcon("tree_directory_open.png"));
				}
				else {
					setIcon(ResourceHandler.createImageIcon("tree_directory_close.png"));					
				}
			}
			else if(file.isFile()){
				setIcon(ResourceHandler.createImageIcon("tree_file.png"));
			}
		}
			
		return this;
		
	}
}
