/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 26, 2007  Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.maker;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import javax.swing.JMenu;

import net.infonode.tabbedpanel.titledtab.TitledTab;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.conf.reader.PropertiesReader;
import com.nate.hjy7942.database.DatabaseConnectionManager;
import com.nate.hjy7942.ui.menu.ViewMenuItem;
import com.nate.hjy7942.ui.tabmodule.DatabaseConnectionTreeTab;
import com.nate.hjy7942.ui.tabmodule.inter.TabComponentInterface;
import com.nate.hjy7942.ui.tabmodule.jspbrowser.JspBrowserTabComponent;
import com.nate.hjy7942.ui.tabmodule.plsqlbrowser.PlsqlBrowserTabComponent;
import com.nate.hjy7942.util.ResourceHandler;

/**
 * ۼ : Aug 26, 2007
 * ۼ : Ҳڹ 
 * <br>
 * frame.propertiesϿ ε  ãƼ ȭ鿡  ش.
 */
public class FrameComponetMaker {
	
	private MainFrame mainFrame = null;
	private HashMap<String, TabComponentInterface> tabTitledTabMap = new HashMap<String, TabComponentInterface>();
	private TitledTab titledTab = null;
	
	public FrameComponetMaker(MainFrame mainFrame){
		this.mainFrame = mainFrame;		
	}
	
	/**
	 * α׷ ȭ鿡    ش.
	 */
	public void makeComponent(){
		String frameFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "frameFile");
		String isVisible = null;
		
		DatabaseConnectionTreeTab databaseConnectionTreeTab = new DatabaseConnectionTreeTab(mainFrame, DatabaseConnectionManager.getInstance());
		titledTab= databaseConnectionTreeTab.getTitledTab();
		tabTitledTabMap.put(databaseConnectionTreeTab.getTabTitle(), databaseConnectionTreeTab);
		isVisible = new PropertiesReader(mainFrame).getPropertyValue(frameFileName, "ConnectionsView");
		if(Boolean.valueOf(isVisible)) {
			databaseConnectionTreeTab.getTabbedPanel().addTab(titledTab);
		}
		
		PlsqlBrowserTabComponent plsqlBrowserTabComponent = new PlsqlBrowserTabComponent(mainFrame);
		titledTab = plsqlBrowserTabComponent.getTitledTab();
		tabTitledTabMap.put(plsqlBrowserTabComponent.getTabTitle(), plsqlBrowserTabComponent);
		isVisible = new PropertiesReader(mainFrame).getPropertyValue(frameFileName, "PL/SQLView");
		if(Boolean.valueOf(isVisible)) {
			plsqlBrowserTabComponent.getTabbedPanel().addTab(titledTab);
		}
		
		JspBrowserTabComponent jspBrowserTabComponent = new JspBrowserTabComponent(mainFrame);
		titledTab = jspBrowserTabComponent.getTitledTab();
		tabTitledTabMap.put(jspBrowserTabComponent.getTabTitle(), jspBrowserTabComponent);
		isVisible = new PropertiesReader(mainFrame).getPropertyValue(frameFileName, "JavaStoredProcedureView");
		if(Boolean.valueOf(isVisible)) {
			jspBrowserTabComponent.getTabbedPanel().addTab(titledTab);
		}
		
		mainFrame.setTabTitledMap(tabTitledTabMap);
		addToolBarMenu();
	}
	
	private void addToolBarMenu(){
		JMenu menu = (JMenu) MenuMaker.getMenu(mainFrame, "WindowShowView");
		Set<String> toolBarSet = tabTitledTabMap.keySet();
		Iterator<String> iter = toolBarSet.iterator();
		
		while(iter.hasNext()){
			TabComponentInterface tabComponent = (TabComponentInterface) tabTitledTabMap.get(iter.next());
			if(tabComponent.getTitledTab().getTabbedPanel() == null) {
				menu.add(new ViewMenuItem(mainFrame, tabComponent, ResourceHandler.createImageIcon("check.gif"), false));
			}
			else {
				menu.add(new ViewMenuItem(mainFrame, tabComponent, ResourceHandler.createImageIcon("check.gif"), true));
			}
		}
	}
}
