/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 21, 2007  Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.maker;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.conf.reader.FontReader;
import com.nate.hjy7942.conf.reader.PropertiesReader;
import com.nate.hjy7942.util.ResourceHandler;

/**
 * ۼ : Aug 15, 2007
 * ۼ : Ҳڹ 
 * <br>
 * α׷ ¹ٸ ִ ü.
 */

public class StateBarMaker {
	
	private MainFrame mainFrame = null;
	private JPanel southPanel = null;
	private JPanel southLeftPanel = null;
	private JPanel southRightPanel = null;

	/**
	 * StateBar ϱ  ü .
	 * @param mainFrame StateBar  θ Frame ӹ ü
	 */
	public StateBarMaker(MainFrame mainFrame){
		this.mainFrame = mainFrame;
		
		southPanel = new JPanel();
		southPanel.setLayout(new GridLayout(1, 2));
		southLeftPanel = new JPanel();
		southLeftPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		southRightPanel = new JPanel();
		southRightPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		
		southPanel.setPreferredSize(new Dimension(0, 23));
		southPanel.add(southLeftPanel);
		southPanel.add(southRightPanel);
		
		mainFrame.setPanelSouth(southPanel);
		mainFrame.getContentPane().add("South", southPanel);
	}
	
	/**
	 * StateBar ϴ Լ
	 */
	public void makeStateBar(){
		ImageIcon stateBarIcon = ResourceHandler.createImageIcon("statebar.png");
		String frameFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "frameFile");

		String currentState_Work = new PropertiesReader(mainFrame).getPropertyValue(frameFileName, "currentstate_work");
		String currentState_Able = new PropertiesReader(mainFrame).getPropertyValue(frameFileName, "currentstate_able");
		String currentState_Insert = new PropertiesReader(mainFrame).getPropertyValue(frameFileName, "currentstate_insert");
		String currentState_CursorLoc = new PropertiesReader(mainFrame).getPropertyValue(frameFileName, "currentstate_cursorloc");
		String currentState_Encording = new PropertiesReader(mainFrame).getPropertyValue(frameFileName, "currentstate_encording");

		if(Boolean.valueOf(currentState_Work)){
			JTextField currentState_WorkField = new JTextField();
			currentState_WorkField.setColumns(40);
			currentState_WorkField.setOpaque(false);
			currentState_WorkField.setBorder(null);
			currentState_WorkField.setFont(FontReader.getStateBarFont(mainFrame));
			southLeftPanel.add(currentState_WorkField);
			mainFrame.setCurrentStateWorkField(currentState_WorkField);
		}
		
		if(Boolean.valueOf(currentState_Able)){
			JTextField currentState_AbleField = new JTextField();
			currentState_AbleField.setColumns(8);
			currentState_AbleField.setOpaque(false);
			currentState_AbleField.setBorder(null);
			currentState_AbleField.setFont(FontReader.getStateBarFont(mainFrame));
			JLabel stateBar2 = new JLabel();
			stateBar2.setIcon(stateBarIcon);
			southRightPanel.add(stateBar2);
			southRightPanel.add(currentState_AbleField);
			mainFrame.setCurrentStateAbleField(currentState_AbleField);
		}
		
		if(Boolean.valueOf(currentState_Insert)){
			JTextField currentState_InsertField = new JTextField();
			currentState_InsertField.setColumns(8);
			currentState_InsertField.setOpaque(false);
			currentState_InsertField.setBorder(null);
			currentState_InsertField.setFont(FontReader.getStateBarFont(mainFrame));
			JLabel stateBar3 = new JLabel();
			stateBar3.setIcon(stateBarIcon);
			southRightPanel.add(stateBar3);
			southRightPanel.add(currentState_InsertField);
			mainFrame.setCurrentStateInsertField(currentState_InsertField);
		}
		
		if(Boolean.valueOf(currentState_CursorLoc)){
			JTextField currentState_CursorLocField = new JTextField();
			currentState_CursorLocField.setColumns(8);
			currentState_CursorLocField.setOpaque(false);
			currentState_CursorLocField.setBorder(null);
			currentState_CursorLocField.setFont(FontReader.getStateBarFont(mainFrame));
			JLabel stateBar4 = new JLabel();
			stateBar4.setIcon(stateBarIcon);
			southRightPanel.add(stateBar4);
			southRightPanel.add(currentState_CursorLocField);
			mainFrame.setCurrentStateCursorLocField(currentState_CursorLocField);
		}
		
		if(Boolean.valueOf(currentState_Encording)){
			JTextField currentState_EncordingField = new JTextField();
			currentState_EncordingField.setColumns(8);
			currentState_EncordingField.setOpaque(false);
			currentState_EncordingField.setBorder(null);
			currentState_EncordingField.setFont(FontReader.getStateBarFont(mainFrame));
			JLabel stateBar5 = new JLabel();
			stateBar5.setIcon(stateBarIcon);
			southRightPanel.add(stateBar5);
			southRightPanel.add(currentState_EncordingField);
			mainFrame.setCurrentStateEncordingField(currentState_EncordingField);
		}
	}
}
