/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 13, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.menu;

import javax.swing.JMenu;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.conf.reader.FontReader;
import com.nate.hjy7942.util.ResourceHandler;

/**
 * ۼ : Aug 13, 2007
 * ۼ : Ҳڹ 
 * <br>
 * α׷ Ǵ  JMenu  Ŭ  ޾Ƽ ϰ ȴ.
 * ⺻ JMenu κ ڷ ޾ƿͼ JMenu .
 */

public abstract class AbstractMenu extends JMenu {

	protected MainFrame mainframe;
	
	/**
	 * JMenu ⺻  XMLϿ о  ޾ .
	 * @param mainFrame MainFrame ü
	 * @param name JMenu ̸
	 * @param caption JMenu 
	 * @param mnemonic JMenu ϸ Ű
	 * @param icon JMenu տ   
	 */
	public AbstractMenu(MainFrame mainFrame, String menuName, String name, String caption, String mnemonic, String icon){
		this.mainframe = mainFrame;
		if(menuName != null){
			this.setName(menuName);
		}
		if(name != null){
			this.setText("  " + name + " ");
		}
		if(caption != null){
			this.setToolTipText(caption);
		}
		if(mnemonic != null){
			this.setMnemonic(mnemonic.charAt(0));
		}
		if(icon != null){
			this.setIcon(ResourceHandler.createImageIcon(icon));
		}
		this.setFont(FontReader.getMenuFont(mainframe));
	}
}
