/**
 * 
 */
package com.nate.hjy7942.ui.menu;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JMenuItem;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.conf.reader.PropertiesReader;
import com.nate.hjy7942.conf.writer.XmlWriter;
import com.nate.hjy7942.util.ResourceHandler;

/**
 * @author Administrator
 *
 */
public class ToolBarMenuItem extends JMenuItem implements ActionListener{
	
	private MainFrame mainFrame = null;
	private boolean flag;
	private ImageIcon img = null;
	private String name = null;
	
	public ToolBarMenuItem(MainFrame mainFrame, String name, ImageIcon img, boolean flag ){
		super(name);
		this.mainFrame = mainFrame;
		this.name = name;
		this.img = img;
		this.flag = flag;
		if(flag) {
			this.setIcon(img);
		}
		
		this.addActionListener(this);
	}

	public void actionPerformed(ActionEvent e) {
		if(flag) {
			flag = false;
			this.setIcon(null);
			mainFrame.getToolBarMap().get(this.getText()).setVisible(false);
			String xmlToolBarFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "toolBarFile");
			XmlWriter.writeDataToXml(xmlToolBarFileName, "toolbaritem", "name", name, "enable", "false");
			
		}
		else {
			flag = true;
			this.setIcon(img);
			mainFrame.getToolBarMap().get(this.getText()).setVisible(true);
			String xmlToolBarFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "toolBarFile");
			XmlWriter.writeDataToXml(xmlToolBarFileName, "toolbaritem", "name", name, "enable", "true");
		}
	}
}
