/*
 * @author Ҳڹ() 
 *
 ********************* [ڵ  丮] ****************************
 *                             
 * [¥]         [۾]             []
 * 2007. 09. 01   Ҳڹ()          Ŭ ó ۼ  
 * 
 ********************************************************************
 */

package com.nate.hjy7942.ui.tabmodule;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;

import net.infonode.tabbedpanel.TabbedPanel;
import net.infonode.tabbedpanel.titledtab.TitledTab;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.database.DatabaseConnectionManager;
import com.nate.hjy7942.ui.tabmodule.inter.TabComponentInterface;
import com.nate.hjy7942.util.ResourceHandler;

/**
 * ۼ : 2007. 09. 01
 * ۼ : Ҳڹ() 
 * <br>
 * ͺ̽ üƮ ϴ ŸƲ  Ŭ<br>
 * @see net.infonode.tabbedpanel.titledtab.TitledTab<br>
 * 
 *  
 */
public class DatabaseConnectionTreeTab implements TabComponentInterface{
	
	private TitledTab titleTap;
	private MainFrame mainFrame;
	private DatabaseConnectionTree connectionsTree;
	private JTree jTree;
	private DefaultMutableTreeNode rootNode;
	private JPanel treePanel;
	private DatabaseConnectionManager dbConnectionModel;
	private String tabTitle = "Connections";

	/**
	 * @param titleTap
	 * @param mainFrame
	 */
	public DatabaseConnectionTreeTab(MainFrame mainFrame, DatabaseConnectionManager dbConnectionModel) {
		this.mainFrame = mainFrame;
		this.dbConnectionModel = dbConnectionModel;
		initialize();
	}
	
	
	
	private void initialize() {
		initializeConnectionTree();
		
		treePanel = new JPanel(new BorderLayout());
		treePanel.add("Center", new JScrollPane(jTree));
		titleTap = new TitledTab(tabTitle, ResourceHandler.createImageIcon("connection.png"),
								treePanel, null);
		titleTap.setName(tabTitle);
	}


	/**
	 * 
	 */
	private void initializeConnectionTree() {
		connectionsTree = new DatabaseConnectionTree(mainFrame, dbConnectionModel);
		jTree = connectionsTree.getTree();
	}



	public TitledTab getTitledTab() {
		return titleTap;
	}
	
	/**
	 * ConnectionNode ߰Ѵ. ߰  connectionTree Ÿ.
	 * @param node
	 */
	public void addConnectionNode(ConnectionNode node) {
		connectionsTree.addConnectionNode(node);
	}
	
	public String getTabTitle() {
		return tabTitle;
	}
	
	public TabbedPanel getTabbedPanel(){
		return mainFrame.getTabbedWest();
	}
}
