/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 26, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.tabmodule.workviewer;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.border.EmptyBorder;

import net.infonode.tabbedpanel.titledtab.TitledTab;
import net.infonode.tabbedpanel.titledtab.TitledTabSizePolicy;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.conf.reader.FontReader;
import com.nate.hjy7942.ui.menu.listener.FileCloseListener;
import com.nate.hjy7942.util.ResourceHandler;

/**
 * 
   * ۼ : 2007. 09. 01
   * ۼ : Ҳڹ 
   * <br>
   * 
 */
public class OrderViewerTabComponent{
	
	private MainFrame mainFrame = null;
	private TitledTab titleTab = null;
	private TextPaneComponent textPane = null;
	
	private static int index = 1;
	
	public OrderViewerTabComponent(MainFrame mainFrame) {
		this.mainFrame = mainFrame;
		init();
	}
	
	private void init(){
		textPane = new TextPaneComponent(mainFrame, "Smart Insert", "Writable", "UTF-8", "temp_" + index++ + ".txt");
		
		titleTab = new TitledTab(textPane.getFileName() , ResourceHandler.createImageIcon("tabtitle_order.png"), new JScrollPane(textPane), null);
		titleTab.setFont(FontReader.getTabTitleFont(this.mainFrame));
		
		JButton closeButton = new JButton();
		closeButton.setIcon(ResourceHandler.createImageIcon("x.png"));
		closeButton.setBorder(new EmptyBorder(0, 0, 0, 0));
		closeButton.setOpaque(false);
		closeButton.addActionListener(FileCloseListener.getInstance(mainFrame));
		
		titleTab.setHighlightedStateTitleComponent(closeButton);
		titleTab.getProperties().setSizePolicy(TitledTabSizePolicy.INDIVIDUAL_SIZE);
	}
	
	public TitledTab getTitledTab(){
		return titleTab;
	}
}
