/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ****************************
 *                             
 * [¥]         [۾]             []
 * 2007. 08. 28   Ҳڹ          Ŭ ó ۼ  
 * 
 ********************************************************************
 */

package com.nate.hjy7942.database;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import junit.framework.TestCase;

/**
 * ۼ : 2007. 08. 28
 * ۼ : Ҳڹ 
 * <br>
 *  ־ ּ!!
 */
public class TestDbConnectionManager extends TestCase {

	public void testDbConnectionManager() {
		DatabaseConnectionManager manager = DatabaseConnectionManager.getInstance();
		DatabaseConnectionManager other = DatabaseConnectionManager.getInstance();
		assertTrue(manager == other);
		
	}
	
	public void testConnection() throws SQLException, IllegalConnectionException {
		DatabaseConnectionManager manager = DatabaseConnectionManager.getInstance();
		Connection connection = manager.get("testJDBC");

		assertNotNull(connection);
		Statement stmt = connection.createStatement();
		ResultSet resultSet = stmt.executeQuery("SELECT employee_id FROM employees");
		resultSet.next();
		assertEquals("100", resultSet.getString(1));
		
	}
	
	public void testScenario() throws IllegalConnectionException {
		DatabaseConnectionManager manager = DatabaseConnectionManager.getInstance();
		
		final String[] propertyNames = { "name", "user", "password",
				"serviceName", "portNumber", "hostName","driver" };

		String[] propertyValues = { "testCreateProperties", "system", "wns2188",
				"XE", "1521", "localhost", "jdbc:oracle:thin" };
		
		DatabaseConnectionProperties dbProperties = new DatabaseConnectionProperties();
		for(int i=0; i<propertyNames.length; i++) {
			dbProperties.setPropertie(propertyNames[i], propertyValues[i]);
		}
		
		DatabaseConnectionHandler handler = new DatabaseConnectionHandler(dbProperties);
		Connection connection = handler.getConnection();
		assertNotNull(handler.getConnection());
		manager.put(handler);
		manager.close();
		
		assertNotNull(manager.get("testJDBC"));
		
	}
	
}
